#include <iostream>
#include <fstream>
//N ist die Konstante fr die Anzahl der Elemente der Suche
#define N 120000000 //160000000 //80000000 //120000000
#define S v[N-1] //v[3]

using namespace std;

//Deklaration von 2 Algorithmen von Suchfunktionen
int linearsuche (int *v, int elem); //Lineare Suche
int binaersuche (int *v, int elem); //Binaere Suche

int main(void)
{
    int zufallwert;
    int *v;  //Variable fr den Suchvektor.
    int i;
    ifstream leseDatei;
    
    v = new int [N]; //Dynamische Reservierung des Suchvektors mit N Elementen
    
    zufallwert = 0;
    
    cout << "Warten whrend der Vektor initialisiert wird\n" << endl;
    cout << "..." << endl;
    
    //Belegung des Vektors mit zuflligen aufsteigenden Elementen
    for (i=1; i<=N; i++)
    {
         zufallwert += rand()%5 + 1;
         v[i] = zufallwert;
    }
    
    //Ausfrung der beiden Suchen
    cout << "Analyse" << endl;
    cout << "Binaere Suche Das Element ist: " << binaersuche(v,S) << endl;
    cout << "Die binaere Suche ist schon fertig.";
    cout << endl;
    cout << "Lineare Suche Das Element ist: " << linearsuche(v,S) << endl;
    cout << "Die lineare Suche ist jetzt fertig.";
   
    system("pause");
    return 0;
    
}

//Definition der Suchfunktionen
int binaersuche (int *v, int elem)
{
    unsigned first = 0; //Untere Position des Suchintervalls
    unsigned last = N-1; //Obige Position des Suchintervalls
    unsigned middle; //Mittelposition des Suchintervalls
    
    //berprfung das an der Grenzen des Intervalls das gesuchte Element nicht ist.
    if ( v[first] == elem)
    {
         return first;
    }
    if  ( v[last] == elem )
    {
        return last;
    }
    
    //Teilung des Intervalls bei der Suche
    while ( last - 1 > first )
    {
          middle = (last + first)/2;
          
          if ( v[middle] == elem)  //Element gefunden als Folge einer Teilung
          {
               return middle; 
          }
          else if ( v[middle] > elem ) //Element nicht gefunden
          {
               last = middle;     
          }
          else
          {
              first = middle;
          }
    }
    //Rckgabe fr die Anwesenheit des gesuchten Elements
    return -1;
}          
                


int linearsuche (int *v, int elem)
{
     unsigned ergebnis;
     unsigned i;
     
     for (i = 0; i < N; i++)
     {
         if (v[i] == elem)
         break;
     }
     
     if (i < N)
     {
        ergebnis = i;
     }
     else
     {
        return -1;
     }
     
     return ergebnis;
}
      
            
